% Solution de l'equation de la chaleur u_t - u_xx = 0 avec des conditions
% aux limites de Dirichlet
clear all
clc

%En espace
n=50;
h = 1/n; % pas de la subdivision en x
x = 0:h:1; %subdivision en x


%En temps
T=1; % temps  de simulation
dt = 0.5*h^2;%  pas de la subdivision en t

% Donnee initiale u_0
u0 = exp(-10*((x-0.5).^2));

% Boucle en temps
t = 0; 
while (t<T)
  r = dt/h^2;  
  % Conditions limites en x =0 intervient ici  
  u(1) = u0(1) + r*(-2*u0(1)+u0(2));
  % Boucle de x_1  x_{n-1}}
  for i=2:n-2
    u(i) = u0(i) + r*(u0(i+1)-2*u0(i)+u0(i-1));
  end
  % Conditions limites en x = 1  intervient ici  
  u(n-1) = u0(n-1) + r*(u0(n-2)-2*u0(n-1));
  u0=u;
  t = t+dt;
  plot(x,[0 u 0])
  axis([0 1 0 1])
  title(['u(x,',num2str(t),')']);
  pause(0.001)
end
